SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/16/2012 21:02'!
book100MasDeUnSigloRojoYBlanco

	^'9789507543340'



! !

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/16/2012 21:02'!
bookLTA

	^'9789876480390'



! !

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/16/2012 21:02'!
bookSerDeRiver

	^'9789500737111'



! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 21:02'!
cartWithOneItemAdded

	|catalogue|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	^(Cart withCatalogue: catalogue) add: self bookLTA  quantity: 1.


	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 21:04'!
creditCardExpiringThisMonthAndValidNumber


	^CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
			

! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/16/2012 23:47'!
fiftyARS

	^MonetaryAmount of: 50 in: MonetaryCurrency ARS.
! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/24/2012 21:48'!
merchantProcessorInterfaceAcceptWithReceiptA

	^MerchantProcessorInterfaceStub respondingOnDebit: [self transactionReceiptA].
! !

!TusLibrosTest methodsFor: 'RejectingMerchantProcessors' stamp: 'BarroumeresLaje 6/24/2012 19:17'!
merchantProcessorInterfaceBadRequest

	^MerchantProcessorInterfaceStub respondingOnDebit: [Error signal: MerchantProcessorInterface errorMessageBadRequest].
! !

!TusLibrosTest methodsFor: 'RejectingMerchantProcessors' stamp: 'BarroumeresLaje 6/24/2012 19:14'!
merchantProcessorInterfaceOffline

	^MerchantProcessorInterfaceStub respondingOnDebit: [Error signal: MerchantProcessorInterface errorMessageSystemDown].
! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/24/2012 14:39'!
merchantProcessorInterfaceREST

	^MerchantProcessorInterfaceREST new.
! !

!TusLibrosTest methodsFor: 'RejectingMerchantProcessors' stamp: 'BarroumeresLaje 6/24/2012 19:16'!
merchantProcessorInterfaceRejectedTransaction

	^MerchantProcessorInterfaceStub respondingOnDebit: [MerchantProcessorInterfaceRejectedOperationError signal:'This is a custom error message generated by Merchant Processor'].
! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/16/2012 23:47'!
oneHundredARS

	^MonetaryAmount of: 100 in: MonetaryCurrency ARS.
! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 21:40'!
test01CartShouldBeEmptyWhenCreated

	|aCart aCatalogue|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.

	self assert: aCart isEmpty.
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 22:51'!
test02CartIsNoLongerEmptyWhenAddingItems

	|aCart aCatalogue|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.
	aCart add: self bookLTA  quantity: 1.
	
	self deny: aCart isEmpty.
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 22:50'!
test03AddToCartAddTheCorrectAmountOfBooksToTheCart

	|aCart aCatalogue q|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.

	q := aCart quantityOf: self bookLTA  .
	aCart add: self bookLTA  quantity:  10.
	self assert: (aCart quantityOf: self bookLTA ) = (10 + q).
	
! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 23:43'!
test04CanNotAddNegativeQuantitiesOfItems

	|aCart aCatalogue q|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.
	
	q := aCart quantityOf: self bookLTA.
 	self should: [aCart add: self bookLTA  quantity: -1] raise: Error.
	self assert: q = (aCart quantityOf: self bookLTA).
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 22:57'!
test05CannotAddBooksFromAnotherPublisherToCart

	"Adding an item which is not in the catalogue should raise a NotFound exception"
	
	|aCart aCatalogue|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.

	self assert: (aCart quantityOf: self bookSerDeRiver) = 0.
	self deny: (aCatalogue includes: self bookSerDeRiver).
	self should: [ (Cart withCatalogue: aCatalogue) add: self bookSerDeRiver quantity: 1] raise: NotFound.
	self assert: (aCart quantityOf: self bookSerDeRiver) = 0.	


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:57'!
test06CannotCheckoutWithAnInvalidNumberedCreditCard

	|catalogue cart aNonNumericCard aWrongSizeCard invocationsBefore aMP|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS;yourself.
	cart := (Cart withCatalogue: catalogue) add: self bookLTA  quantity: 1; yourself.

	aNonNumericCard := CreditCard ownedBy: 'Somebody' identifiedBy: 'aaaabbbbccccdddd' expiresOn: MonthOfYear current.
	aWrongSizeCard := CreditCard ownedBy: 'Somebody' identifiedBy: '11112222333344445' expiresOn: MonthOfYear current.

	aMP := self merchantProcessorInterfaceREST.
	
	invocationsBefore := aMP numberOfInvocations.

	self should: [ Cashier new checkout: cart withCreditCard: aNonNumericCard using: aMP] raise: Error
			withExceptionDo: [:anError | 
				self assert: anError messageText = Cashier errorMessageInvalidCardNumber.
				aMP numberOfInvocations = invocationsBefore ].
	
	invocationsBefore := aMP numberOfInvocations.
	self should: [ Cashier new checkout: cart withCreditCard: aWrongSizeCard using: aMP] raise: Error
			withExceptionDo: [:anError | 
				self assert: anError messageText = Cashier errorMessageInvalidCardNumber.
				aMP numberOfInvocations = invocationsBefore ].
	
	
! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:59'!
test07TotalPriceShouldBeGreaterThanZeroOnCheckout

	|aCatalogue aCart aValidCreditCard invocationsBefore aMerchantProcessorInterface|
	aCatalogue := Dictionary new at: self bookLTA put: self zeroARS; yourself.
	aCart := (Cart withCatalogue: aCatalogue) add: self bookLTA  quantity: 100; yourself.
	aValidCreditCard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.
	invocationsBefore := aMerchantProcessorInterface numberOfInvocations.
	
	self should: [Cashier new checkout: aCart withCreditCard: aValidCreditCard using: aMerchantProcessorInterface] raise: Error  withExceptionDo: [:anError | 
		self assert: anError messageText = Cashier errorMessageInvalidPrice.
		invocationsBefore = aMerchantProcessorInterface numberOfInvocations].
	


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:59'!
test08CannotCheckoutIfCardHasExpired

	"Adding an item which is not in the catalogue should raise a NotFound exception"

	|catalogue cart ccard aMerchantProcessorInterface invocationsBefore|
	catalogue:=Dictionary new at: self book100MasDeUnSigloRojoYBlanco put: self oneHundredARS; yourself.
	cart := (Cart withCatalogue: catalogue) add: self book100MasDeUnSigloRojoYBlanco quantity: 3; yourself.
	ccard := CreditCard ownedBy: 'Somebody'  identifiedBy:  '1111222233334444' expiresOn: (MonthOfYear januaryOf: 1990).
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.
	invocationsBefore := aMerchantProcessorInterface numberOfInvocations.

	"En este caso como una tarjeta vencida se lo podria hasta considerar como parte normal del flujo de eventos modelados por el sistema, reificamos el error pues consideramos que es necesario identificarlo y hacer algo al respecto (por ejemplo, pedirle al cliente que provea otra tarjeta de credito)"
	self should: [ Cashier new checkout: cart withCreditCard: ccard using: aMerchantProcessorInterface] raise: ExpiredCreditCardError withExceptionDo: [:anError | aMerchantProcessorInterface numberOfInvocations = invocationsBefore] .



! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:59'!
test09CannotCheckoutAnEmptyCart

	|catalogue cart ccard aMerchantProcessorInterface invocationsBefore|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	cart := Cart withCatalogue: catalogue.
	ccard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.
	invocationsBefore := aMerchantProcessorInterface numberOfInvocations.
	
	
	self should: [ Cashier new checkout: cart withCreditCard: ccard using: aMerchantProcessorInterface] raise: Error
		withExceptionDo: [:anError | 
			anError messageText = Cashier errorMessageEmptyCard.
			invocationsBefore = aMerchantProcessorInterface numberOfInvocations.]


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:58'!
test10CheckoutKeepsCartInmutability

	|catalogue cart ccard itemsInCart catalogueInCart aMerchantProcessorInterface|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	cart := (Cart withCatalogue: catalogue) add: self bookLTA  quantity: 5.
	ccard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.

	itemsInCart := cart purchasedItems .
	catalogueInCart := cart purchaseCatalogue .

	[Cashier new checkout: cart withCreditCard: ccard using: aMerchantProcessorInterface] on: Error do: [nil].
	
	self assert: (catalogueInCart  = cart purchaseCatalogue).
	self assert: (itemsInCart = cart purchasedItems).
	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 14:57'!
test11CheckoutKeepsCreditCardInmutability

	|catalogue cart ccard itemsInCart catalogueInCart aMerchantProcessorInterface|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	cart := (Cart withCatalogue: catalogue) add: self bookLTA  quantity: 5.
	ccard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	aMerchantProcessorInterface := self merchantProcessorInterfaceREST.

	[Cashier new checkout: cart withCreditCard: ccard using: aMerchantProcessorInterface] on: Error do: [nil].
	
	self assert: (ccard ownerName = 'Somebody').
	self assert: (ccard number = '1111222233334444').
	self assert: (ccard expirationDate = MonthOfYear current ).
	
	

	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 23:34'!
test12RejectedTransactionRaisesError

	|aCart aCreditCard aMerchantProcessorInterface selectors MPs|
	aCart := self cartWithOneItemAdded.
	aCreditCard := self creditCardExpiringThisMonthAndValidNumber.

	selectors := TusLibrosTest organization listAtCategoryNamed: 'RejectingMerchantProcessors'.
	selectors do: [ :aSelector | 
		aMerchantProcessorInterface := self perform: aSelector.  
		self should: [Cashier new checkout: aCart withCreditCard: aCreditCard  using: aMerchantProcessorInterface] raise: Error. ]
	

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 21:52'!
test13AcceptedTransactionRaisesNoError

	|aCart aCreditCard aMerchantProcessorInterface|
	aCart := self cartWithOneItemAdded.
	aCreditCard := self creditCardExpiringThisMonthAndValidNumber.
	aMerchantProcessorInterface := self merchantProcessorInterfaceAcceptWithReceiptA.
	
	self shouldnt: [Cashier new checkout: aCart withCreditCard: aCreditCard  using: aMerchantProcessorInterface] raise: Error.
	
	
	


	
	
	
	
	
	
	

	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 22:03'!
test14CannotCheckoutIfMerchantProcessorInterfaceHasPreviousReceipts

	|aCart aCreditCard aMerchantProcessorInterface aCashier|
	aCart := self cartWithOneItemAdded.
	aCreditCard := self creditCardExpiringThisMonthAndValidNumber.
	aMerchantProcessorInterface := self merchantProcessorInterfaceAcceptWithReceiptA.
	aCashier := Cashier new.
	
	self assert: aMerchantProcessorInterface retrieveLastTransactionReceipt isNone.
	aCashier checkout: aCart withCreditCard: aCreditCard using: aMerchantProcessorInterface.
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard using: aMerchantProcessorInterface] raise: Error
	withExceptionDo:[:anError | 
		self assert: (anError messageText = MerchantProcessorInterface errorMessagePendingReceipts) ]
	
	

		
	
	

	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 22:36'!
test15ApprovedTransactionReturnsAValidTransactionRecord

	|aCart aCreditCard aMerchantProcessorInterface|
	aCart := self cartWithOneItemAdded.
	aCreditCard := self creditCardExpiringThisMonthAndValidNumber.
	aMerchantProcessorInterface := self merchantProcessorInterfaceAcceptWithReceiptA.
	
	Cashier new checkout: aCart withCreditCard: aCreditCard using: aMerchantProcessorInterface.
	self assert: aMerchantProcessorInterface retrieveLastTransactionReceipt isNone not.
	

	
	
	

	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 22:40'!
test16OperationsRejectedByMerchantProcessorSystemRaiseGenericError

	|aCart aCreditCard aMerchantProcessorInterface|
	aCart := self cartWithOneItemAdded.
	aCreditCard := self creditCardExpiringThisMonthAndValidNumber.
	aMerchantProcessorInterface := self merchantProcessorInterfaceRejectedTransaction.
	
	self should:[Cashier new checkout: aCart withCreditCard: aCreditCard  using: aMerchantProcessorInterface] raise: MerchantProcessorInterfaceRejectedOperationError.
	

	
	
	
	
	
	
	

	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 23:36'!
test17MerchantProcessorMustBeOnlineToCheckOut

	|aCart aCreditCard aMerchantProcessorInterface|
	aCart := self cartWithOneItemAdded.
	aCreditCard := self creditCardExpiringThisMonthAndValidNumber.
	aMerchantProcessorInterface := self merchantProcessorInterfaceOffline.
	
	self should:[Cashier new checkout: aCart withCreditCard: aCreditCard  using: aMerchantProcessorInterface] raise: Error withExceptionDo:[:anError | anError messageText = MerchantProcessorInterface errorMessageSystemDown]
	

	
	
	
	
	
	
	

	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/24/2012 23:36'!
test18MerchantProcessorRequestsShouldRespectItsProtocol

	|aCart aCreditCard aMerchantProcessorInterface|
	aCart := self cartWithOneItemAdded.
	aCreditCard := self creditCardExpiringThisMonthAndValidNumber.
	aMerchantProcessorInterface := self merchantProcessorInterfaceBadRequest.
	
	self should:[Cashier new checkout: aCart withCreditCard: aCreditCard  using: aMerchantProcessorInterface] raise: Error withExceptionDo:[:anError | anError messageText = MerchantProcessorInterface errorMessageBadRequest]
	

	
	
	
	
	
	
	

	
		

! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/24/2012 21:23'!
transactionReceiptA

	^TransactionReceipt id:'A'
! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/17/2012 22:14'!
zeroARS

	^MonetaryAmount of: 0 in: MonetaryCurrency ARS.
! !

Error subclass: #MerchantProcessorInterfaceRejectedOperationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'catalogue items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/13/2012 21:41'!
withCatalogue: aSet 
	
	
	 ^self new initializeWithCatalogue: aSet 
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 21:05'!
add: anItem quantity: aNumber


	(catalogue includesKey: anItem) ifFalse: [^NotFound signal: 'No existe el articulo en el catalogo'].
	(aNumber >= 0) ifFalse: [^Error signal: 'Se deben agregar cantidades mayores a cero'].
	
	items add: anItem withOccurrences: aNumber.
	
	

	


	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/13/2012 21:48'!
initializeWithCatalogue: aSet


		catalogue:=aSet.
		items:=Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 09:20'!
isEmpty

	^items isEmpty .
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 20:53'!
purchaseCatalogue

	^catalogue copy.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 20:53'!
purchasedItems

	^items copy.
	


! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 09:31'!
quantityOf: anItem 

	^items occurrencesOf: anItem.
	
! !

Object subclass: #Cashier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 21:55'!
errorMessageEmptyCard 

	^'The cart is empty'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 21:56'!
errorMessageInvalidCardNumber 

	^'Invalid card number'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 22:11'!
errorMessageInvalidPrice

	^'Negative price'! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:52'!
calculatePriceOf: purchasedItems over: aPurchaseCatalogue

	| totalValue |
	
	totalValue := purchasedItems inject: 0 into: [:accum :anItem | 
		| catalogueItem itemUnitPrice | 
		catalogueItem := aPurchaseCatalogue at: anItem.
		itemUnitPrice := catalogueItem amount * catalogueItem currency exchangeRateValue.
		accum + itemUnitPrice].

	^MonetaryAmount of: totalValue in: MonetaryCurrency ARS.
	
	
	! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 21:38'!
checkout: aCart withCreditCard: aCreditCard using: aMerchantProcessorInterface 

	| totalPrice |

	self validateCreditCard: aCreditCard.

	totalPrice := self calculatePriceOf: aCart purchasedItems over: aCart purchaseCatalogue.
	self validateTotalPrice: totalPrice.
	
	aMerchantProcessorInterface debitFrom: aCreditCard  theAmountOf:  totalPrice.

	


	
	
	
	
	! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 22:13'!
validateCreditCard: aCreditCard

	(aCreditCard isExpiredOn: MonthOfYear current) ifTrue:[^ExpiredCreditCardError signal: 'Tarjeta vencida'].
	(aCreditCard number matchesRegex: '[0-9]+') ifFalse: [^Error signal: Cashier errorMessageInvalidCardNumber].
	(aCreditCard number size = 16) ifFalse: [^Error signal: Cashier errorMessageInvalidCardNumber].
! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 23:38'!
validateTotalPrice: aMonetaryAmount 

	(aMonetaryAmount amount > 0) ifFalse: [^Error signal: Cashier errorMessageInvalidPrice].


	
	
	
	
	! !

Object subclass: #MerchantProcessorInterface
	instanceVariableNames: 'numberOfInvocations lastTransactionReceipt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorInterface class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 18:56'!
errorMessageBadRequest

	^'HTTP400 Bad Request'
! !

!MerchantProcessorInterface class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 21:59'!
errorMessagePendingReceipts 

	^'Hay recibos pendientes para entregar'
! !

!MerchantProcessorInterface class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 19:08'!
errorMessageSystemDown

	^'Merchant Processor fuera de linea'


! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:06'!
debitFrom: aCreditCard theAmountOf: aMonetaryAmount 

	^self subclassResponsibility .! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 21:39'!
initialize

	numberOfInvocations := 0.
	lastTransactionReceipt := TransactionReceipt pending.
! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:22'!
logDebit

	numberOfInvocations := numberOfInvocations  + 1.
! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:39'!
numberOfInvocations 

	^numberOfInvocations .! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 22:01'!
retrieveLastTransactionReceipt 

	|aReceipt|
	aReceipt := lastTransactionReceipt .
	lastTransactionReceipt := TransactionReceipt pending.
	
	
	^aReceipt .
! !

MerchantProcessorInterface subclass: #MerchantProcessorInterfaceREST
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorInterfaceREST methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:37'!
debitFrom: aCreditCard theAmountOf: aMonetaryAmount 

	self logDebit.
	^self shouldBeImplemented .! !

MerchantProcessorInterface subclass: #MerchantProcessorInterfaceStub
	instanceVariableNames: 'onDebitRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorInterfaceStub class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:10'!
respondingOnDebit: aDebitResponse

	^self new initializeWithDebitResponse: aDebitResponse ! !

!MerchantProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 22:33'!
debitFrom: aCreditCard theAmountOf: aMonetaryAmount 
	


	self logDebit.
	lastTransactionReceipt isNone ifFalse: [Error signal: MerchantProcessorInterface errorMessagePendingReceipts].
	
	lastTransactionReceipt  := onDebitRequest value.

! !

!MerchantProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 14:11'!
initializeWithDebitResponse: aDebitResponse


	onDebitRequest := aDebitResponse.! !

Object subclass: #MonetaryAmount
	instanceVariableNames: 'currencyValue amountValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MonetaryAmount class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 20:10'!
of: anAmount in: aCurrency


^self new initializeWithAmount: anAmount in: aCurrency.
! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:32'!
amount 

	^amountValue
	! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:32'!
currency

	^currencyValue ! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:32'!
initializeWithAmount: anAmount  in: aCurrency


	amountValue := anAmount.
	currencyValue := aCurrency.
	! !

Object subclass: #MonetaryCurrency
	instanceVariableNames: 'name rate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MonetaryCurrency class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:45'!
ARS

	^self named: 'ARS' withRate: 1.
	! !

!MonetaryCurrency class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 20:41'!
named: aName withRate: anExchangeRate

	^self new initializeWithName: aName rate: anExchangeRate.! !

!MonetaryCurrency methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:33'!
exchangeRateValue

^rate.
! !

!MonetaryCurrency methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 20:27'!
initializeWithName: aName rate: anExchangeRate


	name := aName.
	rate := anExchangeRate.! !

Object subclass: #Purchase
	instanceVariableNames: 'client cart transactionRecord'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Purchase class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 19:41'!
approvedFor: aClient ofItems: aCart withTransactionRecord: aTransactionRecord

	^self new initializeFor: aClient ofItems: aCart withTransactionRecord: aTransactionRecord .! !

!Purchase class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 21:22'!
rejectedFor: aClient ofItems: aCart


	^self new initializeFor: aClient ofItems: aCart withCoupon: TransactionReceipt pending.! !

!Purchase methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 19:45'!
initializeFor: aClient ofItems: aCart withTransactionRecord: aTransactionRecord 


	client:=aClient.
	cart:=aCart.
	transactionRecord=aTransactionRecord.
	! !

Object subclass: #RegisterBatch
	instanceVariableNames: 'registerType registerRemainder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!RegisterBatch class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 18:01'!
initializeWith: aString andCatalogue: aCatalogue

	| col registerType |
	
	col := (aString subStrings: ',') asOrderedCollection.
	
	registerType := (col at: 1) copy.
	
	(registerType = '1') ifTrue: [^RegisterBatchAddToCart initializeWith: aString andCatalogue: aCatalogue] 
	                             ifFalse: [^RegisterBatchCheckout initializeWith: aString andCatalogue: aCatalogue] 
	
	! !

!RegisterBatch methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 17:47'!
initializeWith: aString andCatalogue: aCatalogue

	| col |

	col := (aString subStrings: ',') asOrderedCollection.
	
	registerType := (col at: 1) copy.
	col removeAt: 1.
	registerRemainder := col copy.
	! !

!RegisterBatch methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 16:40'!
processRegister
	"comment stating purpose of message"

	| temporary variable names |
	self subclassResponsibility ! !

!RegisterBatch methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 17:24'!
registerRemainder
	^ registerRemainder! !

!RegisterBatch methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 17:23'!
registerType
	^ registerType ! !

RegisterBatch subclass: #RegisterBatchAddToCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!RegisterBatchAddToCart class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 18:06'!
initializeWith: aString andCatalogue: aCatalogue

	^self new initializeWith: aString andCatalogue: aCatalogue! !

!RegisterBatchAddToCart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 18:07'!
initializeWith: aString andCatalogue: aCatalogue

	super initializeWith: aString andCatalogue: aCatalogue.
	


! !

!RegisterBatchAddToCart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 17:37'!
processRegister 
	"comment stating purpose of message"
	| aCart aCreditCard aCatalogue aBook anAmount |

	aBook := registerRemainder at: 1.        "libro"
	anAmount := registerRemainder at: 2.        "cantidad"
	
	aCart := Cart withCatalogue: Set new.
	"siempre lo crea el carrito..."
	
	aCart add: aBook quantity: anAmount.
	


! !

RegisterBatch subclass: #RegisterBatchCheckout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!RegisterBatchCheckout class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 18:06'!
initializeWith: aString andCatalogue: aCatalogue

	^self new initializeWith: aString andCatalogue: aCatalogue! !

!RegisterBatchCheckout methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 18:07'!
initializeWith: aString andCatalogue: aCatalogue

	super initializeWith: aString andCatalogue: aCatalogue.
	

	
	
! !

!RegisterBatchCheckout methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/25/2012 17:40'!
processRegister 

	"comment stating purpose of message"
	| aCart aCashier aClient anExpiration aCreditCard aCatalogue aBook anAmount |

	aCreditCard := registerRemainder at: 1.         " tarjeta de credito"
	anExpiration := registerRemainder at: 2.        " cantidad"
	aClient := registerRemainder at: 3.        		 " owner"
	
	aCart := Cart withCatalogue: Set new.
	"siempre lo crea el carrito..."

	aCashier checkout: aCart withCreditCard: aCreditCard using: nil.

	
	
! !

Object subclass: #TransactionReceipt
	instanceVariableNames: 'transactionRecordId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TransactionReceipt class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 21:22'!
id: aTransactionRecordId


	^TransactionReceiptConfirmed new initializeWithId: aTransactionRecordId.
	! !

!TransactionReceipt class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 22:02'!
pending

	^TransactionReceiptNone new.
	! !

!TransactionReceipt methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 22:07'!
ifNone: aBlock

	^self isNone ifTrue: aBlock
	! !

!TransactionReceipt methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 22:02'!
isNone

	^self subclassResponsibility.! !

TransactionReceipt subclass: #TransactionReceiptConfirmed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TransactionReceiptConfirmed methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 19:43'!
initializeWithId: aTransactionRecordId


	transactionRecordId := aTransactionRecordId.! !

!TransactionReceiptConfirmed methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 22:02'!
isNone 

	^false
	! !

TransactionReceipt subclass: #TransactionReceiptNone
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TransactionReceiptNone methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 19:43'!
initializeWithId: aTransactionRecordId

	^self shouldNotImplement .
	! !

!TransactionReceiptNone methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/24/2012 22:02'!
isNone

	^true
	! !
